<?php

/*
Plugin Name: Digg Digg
Version: 3.9.6
Plugin URI: http://www.mkyong.com/blog/digg-digg-wordpress-plugin
Author: Yong Mook Kim
Author URI: http://www.mkyong.com/
Description: All-in-One social vote buttons - Digg, Reddit, dDone, Yahoo Buzz, TweetMeme(twitter), facebook share, facebook like, Polladium, StumbleUpon, Delicious, Sphinn, Post comments, Google Buzz, Designbump, Designfloat and Thewebblend

http://digg.com/tools/integrate
http://www.reddit.com/buttons/
http://www.reddit.com/upgradebuttons
http://in.buzz.yahoo.com/buttons
http://www.dzone.com/links/buttons.jsp
http://tweetmeme.com/about/retweet_button
http://www.fbshare.me/
http://wiki.developers.facebook.com/index.php/Facebook_Share
http://www.facebook.com/facebook-widgets/share.php
http://developers.facebook.com/docs/reference/plugins/like
http://www.polladium.com/poll-this_get_badge.php
http://www.stumbleupon.com/buttons/
http://delicious.com/help/tools
http://delicious.com/help/savebuttons
http://sphinn.com/widgets/
http://code.google.com/apis/buzz/
http://buzrr.com/buttonselect.php?lang=en
http://thewebblend.com/tools/vote
http://www.designfloat.com/tools-en.php
http://designbump.com/content/evb
http://developerwiki.myspace.com/index.php?title=How_to_Add_Post_To_MySpace_to_Your_Site
http://www.google.com/buzz/api/admin/configPostWidget
http://www.blogengage.com/profile_promo.php
*/ 

/*
ini_set('display_errors',1);
error_reporting(E_ALL);
*/

//include required class
require_once 'dd.class.php';
require_once 'dd.constant.php';
require_once 'dd.printform.php';


//add digg digg div output style
function digg_digg_stylesheet_div()
{
	echo '<link rel="stylesheet" href="'. get_bloginfo('wpurl') . '/wp-content/plugins/digg-digg/';
	echo 'diggdigg-style-div.css?ver=' . DD_VERSION . '" type="text/css" media="screen" />';
}

//ajax left float settins
function digg_digg_ajax_float()
{
	
	if(get_option(DD_AJAX_LEFT_FLOAT_OPTION)==DD_DISPLAY_ON && is_single()){
		
		//need to load JQuery library?
		if(get_option(DD_AJAX_LIBRARY)==DD_DISPLAY_ON){
			echo '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>';
		}
		
		echo '<style type="text/css" media="screen">' . get_option(DD_AJAX_INITIAL_POSITION) . '</style>';
		echo '<script type="text/javascript">' . get_option(DD_AJAX_SCROLLING_POSITION) . '</script>';
	}
	
}

function dd_filter_weird_characters($str){
	
	$str = str_replace("\\\"", "\"", $str);
	$str = str_replace("\'", "'", $str);
	
	return $str;
}

//Wordpress Hook Hook
add_action(DD_WP_ADMIN_MENU, DD_ADMIN_MENU);
add_filter(DD_WP_THE_CONTENT, DD_CONTENT_HOOK);
//add_filter(DD_WP_THE_EXCERPT, DD_CONTENT_HOOK);

add_action(DD_WP_HEAD, 'digg_digg_stylesheet_div');
add_action(DD_WP_HEAD, 'digg_digg_ajax_float');

//plugin initial during activation, reset all value
register_activation_hook( __FILE__, 'digg_digg_initialIt');

/**
 * Initial the value
 * @param $type , reset or initial , DD_FUNC_TYPE_RESET or DD_FUNC_TYPE_INITIAL
 */
function digg_digg_DataInitialer($type=DD_FUNC_TYPE_RESET){
	$dd_digg = new DD_Digg();
	$dd_reddit = new DD_Reddit();
	$dd_dzone = new DD_Dzone();
	$dd_ybuzz = new DD_YBuzz();
	$dd_twitter = new DD_Twitter();
	$dd_fbshare = new DD_FbShare();
	$dd_fblike = new DD_FbLike();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();
	$dd_designbump = new DD_DesignBump();
	$dd_designfloat = new DD_DesignFloat();
	$dd_webblend = new DD_WebBlend();
	$dd_blogengage = new DD_BlogEngage();

	if(get_option(DD_DIGG_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DIGG_OPTIONS, $dd_digg->wp_options);
	
	if(get_option(DD_REDDIT_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_REDDIT_OPTIONS, $dd_reddit->wp_options);
		
	if(get_option(DD_DZONE_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DZONE_OPTIONS, $dd_dzone->wp_options);
		
	if(get_option(DD_YBUZZ_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_YBUZZ_OPTIONS, $dd_ybuzz->wp_options);
		
	if(get_option(DD_TWITTER_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_TWITTER_OPTIONS, $dd_twitter->wp_options);
		
	if(get_option(DD_FBSHARE_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_FBSHARE_OPTIONS, $dd_fbshare->wp_options);
	
	if(get_option(DD_FBLIKE_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_FBLIKE_OPTIONS, $dd_fblike->wp_options);
	
	if(get_option(DD_POLLADIUM_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_POLLADIUM_OPTIONS, $dd_polladium->wp_options);
	
	if(get_option(DD_STUMBLEUPON_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_STUMBLEUPON_OPTIONS, $dd_stumbleupon->wp_options);
	
	if(get_option(DD_DELICIOUS_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DELICIOUS_OPTIONS, $dd_delicious->wp_options);

	if(get_option(DD_SPHINN_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_SPHINN_OPTIONS, $dd_sphinn->wp_options);
		
	if(get_option(DD_COMMENTS_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_COMMENTS_OPTIONS, $dd_comments->wp_options);
	
	if(get_option(DD_GBUZZ_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_GBUZZ_OPTIONS, $dd_gbuzz->wp_options);
		
	if(get_option(DD_DESIGNDUMP_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DESIGNDUMP_OPTIONS, $dd_designbump->wp_options);
		
	if(get_option(DD_DESIGNFLOAT_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DESIGNFLOAT_OPTIONS, $dd_designfloat->wp_options);
	
	if(get_option(DD_WEBBLEND_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_WEBBLEND_OPTIONS, $dd_webblend->wp_options);

	if(get_option(DD_BLOGENGAGE_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_BLOGENGAGE_OPTIONS, $dd_blogengage->wp_options);
		
	if(get_option(DD_DISPLAY_HOME)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_HOME, DD_DISPLAY_OFF);
		
	if(get_option(DD_DISPLAY_PAGE)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_PAGE, DD_DISPLAY_OFF);
		
	if(get_option(DD_DISPLAY_POST)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_POST, DD_DISPLAY_ON);
		
	if(get_option(DD_DISPLAY_CATEGORY)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_CATEGORY, DD_DISPLAY_OFF);
	
	if(get_option(DD_DISPLAY_ARCHIVE)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_ARCHIVE, DD_DISPLAY_OFF);
	
	if(get_option(DD_LINE_UP)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_LINE_UP, DD_LINE_UP_HORIZONTAL);
	
	
	if(get_option(DD_TWITTER_SOURCE)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_TWITTER_SOURCE, DD_EMPTY_VALUE);
	
	if(get_option(DD_CATEGORY_ALLOW)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_CATEGORY_ALLOW, DD_ALL_VALUE);	
	
	//ajax left float settings
	if(get_option(DD_AJAX_LEFT_FLOAT_OPTION)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_AJAX_LEFT_FLOAT_OPTION, DD_DISPLAY_OFF);	
		
	if(get_option(DD_AJAX_LIBRARY)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_AJAX_LIBRARY, DD_DISPLAY_OFF);	
	
	if(get_option(DD_AJAX_INITIAL_POSITION)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_AJAX_INITIAL_POSITION, DD_AJAX_INITIAL_POSITION_VALUE);	
	
	if(get_option(DD_AJAX_SCROLLING_POSITION)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_AJAX_SCROLLING_POSITION, DD_AJAX_SCROLLING_POSITION_VALUE);	
	
}

//reset all the value
function digg_digg_resetIt(){
	digg_digg_DataInitialer(DD_FUNC_TYPE_RESET);	
}

//initial the unset value
function digg_digg_initialIt(){
	digg_digg_DataInitialer(DD_FUNC_TYPE_INITIAL);
}

//add digg digg menu
function digg_digg_admin_menu() {
	//add_submenu_page(DD_WP_OPTIONS_GENERAL, DD_OPTIONS, DD_NAME, 8, DD_NAME , DD_MENU);
	add_submenu_page(DD_WP_OPTIONS_GENERAL, DD_OPTIONS, DD_NAME, 8, basename(__FILE__), DD_MENU);
	//add_options_page(DD_OPTIONS, DD_NAME, 8, basename(__FILE__), DD_MENU);
}

function digg_digg_menu(){
	
	$dd_digg = new DD_Digg();
	$dd_reddit = new DD_Reddit();
	$dd_dzone = new DD_Dzone();
	$dd_ybuzz = new DD_YBuzz();
	$dd_twitter = new DD_Twitter();
	$dd_fbshare = new DD_FbShare();
	$dd_fblike = new DD_FbLike();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();
	$dd_designbump = new DD_DesignBump();
	$dd_designfloat = new DD_DesignFloat();
	$dd_webblend = new DD_WebBlend();
	$dd_blogengage = new DD_BlogEngage();
	
	if (isset($_POST[DD_FORM_SAVE])) {

	    //digg.com
	    foreach(array_keys($dd_digg->wp_options) as $key){
	    	$dd_digg->wp_options[$key] = $_POST[$key];
	    }
		    
	    //reddit.com
	    foreach(array_keys($dd_reddit->wp_options) as $key){
	    	$dd_reddit->wp_options[$key] = $_POST[$key];
	    }

	    //dzone.com
		foreach(array_keys($dd_dzone->wp_options) as $key){
	    	$dd_dzone->wp_options[$key] = $_POST[$key];
	    }
	    
	    //yahoo buzz
		foreach(array_keys($dd_ybuzz->wp_options) as $key){
	    	$dd_ybuzz->wp_options[$key] = $_POST[$key];
	    }
	    
		//twitter
		foreach(array_keys($dd_twitter->wp_options) as $key){
	    	$dd_twitter->wp_options[$key] = $_POST[$key];
	    }
	    
		//facebook
		foreach(array_keys($dd_fbshare->wp_options) as $key){
	    	$dd_fbshare->wp_options[$key] = $_POST[$key];
	    }
	    
	    //facebook like
	    foreach(array_keys($dd_fblike->wp_options) as $key){
	    	$dd_fblike->wp_options[$key] = $_POST[$key];
	    }
	    
		//polladium
		foreach(array_keys($dd_polladium->wp_options) as $key){
	    	$dd_polladium->wp_options[$key] = $_POST[$key];
	    }
	
	    //stumbleupon
	    foreach(array_keys($dd_stumbleupon->wp_options) as $key){
	    	$dd_stumbleupon->wp_options[$key] = $_POST[$key];
	    }
	    
		//delicious
	    foreach(array_keys($dd_delicious->wp_options) as $key){
	    	$dd_delicious->wp_options[$key] = $_POST[$key];
	    }
	    
		//sphinn
	    foreach(array_keys($dd_sphinn->wp_options) as $key){
	    	$dd_sphinn->wp_options[$key] = $_POST[$key];
	    }
	    
		//post comments
	    foreach(array_keys($dd_comments->wp_options) as $key){
	    	$dd_comments->wp_options[$key] = $_POST[$key];
	    }
	    
		//Google Buzz
	    foreach(array_keys($dd_gbuzz->wp_options) as $key){
	    	$dd_gbuzz->wp_options[$key] = $_POST[$key];
	    }
	    
		//Designbump
	    foreach(array_keys($dd_designbump->wp_options) as $key){
	    	$dd_designbump->wp_options[$key] = $_POST[$key];
	    }
	    
		//Designfloat 
	    foreach(array_keys($dd_designfloat->wp_options) as $key){
	    	$dd_designfloat->wp_options[$key] = $_POST[$key];
	    }
	    
		//TheWebBlend 
	    foreach(array_keys($dd_webblend->wp_options) as $key){
	    	$dd_webblend->wp_options[$key] = $_POST[$key];
	    }
	    
	    //BlogEngage
	    foreach(array_keys($dd_blogengage->wp_options) as $key){
	    	$dd_blogengage->wp_options[$key] = $_POST[$key];
	    }
	    
		update_option(DD_DIGG_OPTIONS, $dd_digg->wp_options);
		update_option(DD_REDDIT_OPTIONS, $dd_reddit->wp_options);
		update_option(DD_DZONE_OPTIONS, $dd_dzone->wp_options);
		update_option(DD_YBUZZ_OPTIONS, $dd_ybuzz->wp_options);
		update_option(DD_TWITTER_OPTIONS, $dd_twitter->wp_options);
		update_option(DD_FBSHARE_OPTIONS, $dd_fbshare->wp_options);
		update_option(DD_FBLIKE_OPTIONS, $dd_fblike->wp_options);
		update_option(DD_POLLADIUM_OPTIONS, $dd_polladium->wp_options);
		update_option(DD_STUMBLEUPON_OPTIONS, $dd_stumbleupon->wp_options);
		update_option(DD_DELICIOUS_OPTIONS, $dd_delicious->wp_options);
		update_option(DD_SPHINN_OPTIONS, $dd_sphinn->wp_options);
		update_option(DD_COMMENTS_OPTIONS, $dd_comments->wp_options);
		update_option(DD_GBUZZ_OPTIONS, $dd_gbuzz->wp_options);
		update_option(DD_DESIGNDUMP_OPTIONS, $dd_designbump->wp_options);
		update_option(DD_DESIGNFLOAT_OPTIONS, $dd_designfloat->wp_options);
		update_option(DD_WEBBLEND_OPTIONS, $dd_webblend->wp_options);
		update_option(DD_BLOGENGAGE_OPTIONS, $dd_blogengage->wp_options);
		
		//should not check with isset(), cause failed to uncheck the check box
		//if(isset($_POST[DD_DISPLAY_HOME]))
	    //	update_option(DD_DISPLAY_HOME, $_POST[DD_DISPLAY_HOME]);
		
		update_option(DD_DISPLAY_HOME, $_POST[DD_DISPLAY_HOME]);
	    update_option(DD_DISPLAY_PAGE, $_POST[DD_DISPLAY_PAGE]);
	    update_option(DD_DISPLAY_POST, $_POST[DD_DISPLAY_POST]);
		update_option(DD_DISPLAY_CATEGORY, $_POST[DD_DISPLAY_CATEGORY]);
		update_option(DD_DISPLAY_ARCHIVE, $_POST[DD_DISPLAY_ARCHIVE]);
	
		//update ajax float settings
		update_option(DD_AJAX_LEFT_FLOAT_OPTION, $_POST[DD_AJAX_LEFT_FLOAT_OPTION]);	
		update_option(DD_AJAX_LIBRARY, $_POST[DD_AJAX_LIBRARY]);
		update_option(DD_AJAX_INITIAL_POSITION, dd_filter_weird_characters($_POST[DD_AJAX_INITIAL_POSITION]));
		update_option(DD_AJAX_SCROLLING_POSITION, dd_filter_weird_characters($_POST[DD_AJAX_SCROLLING_POSITION]));
	
		//update line up option
		update_option(DD_LINE_UP, $_POST[DD_LINE_UP]);
			
		//update twitter source
		update_option(DD_TWITTER_SOURCE, $_POST[DD_TWITTER_SOURCE]);
		
		//update category name
		update_option(DD_CATEGORY_ALLOW, $_POST[DD_CATEGORY_ALLOW]);
		
		echo '<div id="message" class="updated fade"><p>Updated.</p></div>';
		
  	}else if(isset($_POST[DD_FORM_CLEAR])){
	
        digg_digg_resetIt();
		echo "<div id='message' class='error fade'><p>Settings Cleared.</p></div>";
			
  	}

  	//load options from db
  	$dd_digg->wp_options = get_option(DD_DIGG_OPTIONS);
  	$dd_reddit->wp_options = get_option(DD_REDDIT_OPTIONS);
  	$dd_dzone->wp_options = get_option(DD_DZONE_OPTIONS);
  	$dd_ybuzz->wp_options = get_option(DD_YBUZZ_OPTIONS);
  	$dd_twitter->wp_options = get_option(DD_TWITTER_OPTIONS);
  	$dd_fbshare->wp_options = get_option(DD_FBSHARE_OPTIONS);
  	$dd_fblike->wp_options = get_option(DD_FBLIKE_OPTIONS);
  	$dd_polladium->wp_options = get_option(DD_POLLADIUM_OPTIONS);
    $dd_stumbleupon->wp_options = get_option(DD_STUMBLEUPON_OPTIONS);
  	$dd_delicious->wp_options = get_option(DD_DELICIOUS_OPTIONS);
  	$dd_sphinn->wp_options = get_option(DD_SPHINN_OPTIONS);
  	$dd_comments->wp_options = get_option(DD_COMMENTS_OPTIONS);
  	$dd_gbuzz->wp_options = get_option(DD_GBUZZ_OPTIONS);
  	$dd_designbump->wp_options = get_option(DD_DESIGNDUMP_OPTIONS);
  	$dd_designfloat->wp_options = get_option(DD_DESIGNFLOAT_OPTIONS);
  	$dd_webblend->wp_options = get_option(DD_WEBBLEND_OPTIONS);
  	$dd_blogengage->wp_options = get_option(DD_BLOGENGAGE_OPTIONS);
  	
  	$dd_buttons = array($dd_digg,$dd_reddit,$dd_dzone,$dd_ybuzz,$dd_twitter,$dd_fbshare,$dd_fblike,$dd_polladium,$dd_stumbleupon,$dd_delicious,$dd_sphinn,$dd_comments,$dd_gbuzz,$dd_designbump,$dd_designfloat,$dd_webblend,$dd_blogengage);
  	// display admin screen
  	print_digg_digg_menu_form($dd_buttons);
  
}

/**
 * Validate whether allow the digg digg button display
 * @return true allow display, false not allow to display
 */
function digg_digg_isDisplay(){
	//get display option
    $dd_display_home = get_option(DD_DISPLAY_HOME);
	$dd_display_page = get_option(DD_DISPLAY_PAGE);
	$dd_display_post = get_option(DD_DISPLAY_POST);
	$dd_display_category = get_option(DD_DISPLAY_CATEGORY);
	$dd_display_archive = get_option(DD_DISPLAY_ARCHIVE);
	
	//TODO: can it display in feed?
	$dd_display_feed = DD_DISPLAY_OFF;

	if(is_home() && ($dd_display_home==DD_DISPLAY_ON)){
		return true;
	}else if(is_feed() && ($dd_display_feed==DD_DISPLAY_ON)){
		return true;
	}else if(is_single() && ($dd_display_post==DD_DISPLAY_ON)){
		return true;
	}else if(is_category() && ($dd_display_category==DD_DISPLAY_ON)){
		return true;
	}else if(is_page() && ($dd_display_page==DD_DISPLAY_ON)){
		return true;
	}else if(is_archive() && ($dd_display_archive==DD_DISPLAY_ON)){
		return true;
	}else{
		return false;
	}
}


/**
 * Validate whether allow the digg digg button display
 * @return true allow display, false not allow to display
 */
function digg_digg_isDisplayDisabled($content){
	
	if (preg_match("/" . DD_DISABLED . "/i", $content)) {
	    return true;
	} else {
	    return false;
	}
	
}

/**
 * Validate whether the category is allow to display
 * @return true allow display, false not allow to display
 */
function digg_digg_isCategoryAllow($category_allow){
	
	$category_allow = trim(strtolower($category_allow));
	
	//echo 'Category allow : ' . $category_allow; 
	
	if($category_allow == '' || ($category_allow==strtolower(DD_ALL_VALUE))){
		return true;
	}

	$cats_allow = explode(",", strtolower($category_allow));

	foreach((get_the_category()) as $post_category) { 
		
		//echo '<br/> category name : ' . $post_category->cat_name; 
		
		foreach($cats_allow as $cat_allow){
			
			$post_category_name = strtolower($post_category->cat_name);
			
			//echo '<br/>Category allow loop : ' . $cat_allow . '<br/> category name : ' . $post_category_name;

			if($post_category_name==trim($cat_allow)){
				//echo ' match';
				return true;
			}else{
				//echo ' not match';
			}
		}
	}
	return false;
}

function digg_digg_content_hook($content = ''){

    global $wp_query;
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $comments = $post->comment_count; //get post comments
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
 
    $dd_category_allow = get_option(DD_CATEGORY_ALLOW);
    
    //allow to display?
    if(digg_digg_isDisplay()==false || digg_digg_isDisplayDisabled($content)==true || digg_digg_isCategoryAllow($dd_category_allow)==false){
    	return $content;
    }
   
    $dd_line_up = get_option(DD_LINE_UP);	 
    $dd_twitter_source = get_option(DD_TWITTER_SOURCE);
    
    $dd_digg = new DD_Digg();
    $dd_reddit = new DD_Reddit();
    $dd_dzone = new DD_Dzone();
    $dd_ybuzz = new DD_YBuzz();
    $dd_twitter = new DD_Twitter();
    $dd_fbshare = new DD_FbShare();
    $dd_fblike = new DD_FbLike();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
  	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();
	$dd_designbump = new DD_DesignBump();
	$dd_designfloat = new DD_DesignFloat();
	$dd_webblend = new DD_WebBlend();
	$dd_blogengage = new DD_BlogEngage();
	
    $dd_digg->wp_options = get_option(DD_DIGG_OPTIONS);	 
    $dd_reddit->wp_options = get_option(DD_REDDIT_OPTIONS);	 
	$dd_dzone->wp_options = get_option(DD_DZONE_OPTIONS);
	$dd_ybuzz->wp_options = get_option(DD_YBUZZ_OPTIONS);
	$dd_twitter->wp_options = get_option(DD_TWITTER_OPTIONS);
	$dd_fbshare->wp_options = get_option(DD_FBSHARE_OPTIONS);
	$dd_fblike->wp_options = get_option(DD_FBLIKE_OPTIONS);
	$dd_polladium->wp_options = get_option(DD_POLLADIUM_OPTIONS);
	$dd_stumbleupon->wp_options = get_option(DD_STUMBLEUPON_OPTIONS);
	$dd_delicious->wp_options = get_option(DD_DELICIOUS_OPTIONS);
	$dd_sphinn->wp_options = get_option(DD_SPHINN_OPTIONS);
	$dd_comments->wp_options = get_option(DD_COMMENTS_OPTIONS);
	$dd_gbuzz->wp_options = get_option(DD_GBUZZ_OPTIONS);
	$dd_designbump->wp_options = get_option(DD_DESIGNDUMP_OPTIONS);
	$dd_designfloat->wp_options = get_option(DD_DESIGNFLOAT_OPTIONS);
	$dd_webblend->wp_options = get_option(DD_WEBBLEND_OPTIONS);
	$dd_blogengage->wp_options = get_option(DD_BLOGENGAGE_OPTIONS);

    //generate vote link
    $dd_digg->construstURL($link[0],$title,$dd_digg->get_button_design());
    $dd_reddit->construstURL($link[0],$title,$dd_reddit->get_button_design());
    $dd_dzone->construstURL($link[0],$title,$dd_dzone->get_button_design());
    $dd_ybuzz->construstURL($link[0],$title,$dd_ybuzz->get_button_design());
    $dd_twitter->construstURL($link[0],$dd_twitter_source,$dd_twitter->get_button_design());
    $dd_fbshare->construstURL($link[0],$title,$dd_fbshare->get_button_design());
    $dd_fblike->construstURL($link[0],$title,$dd_fblike->get_button_design());
    $dd_polladium->construstURL($link[0],$title,$dd_polladium->get_button_design());
    $dd_stumbleupon->construstURL($link[0],$title,$dd_stumbleupon->get_button_design());
    $dd_delicious->construstURL($link[0],$title,$dd_delicious->get_button_design());
    $dd_sphinn->construstURL($link[0],$title,$dd_sphinn->get_button_design());
    $dd_comments->construstURL($link[0],$comments);
    $dd_gbuzz->construstURL($link[0],$title,$dd_gbuzz->get_button_design());
    $dd_designbump->construstURL($link[0],$title,$dd_designbump->get_button_design());
    $dd_designfloat->construstURL($link[0],$title,$dd_designfloat->get_button_design());
    $dd_webblend->construstURL($link[0],$title,$dd_webblend->get_button_design());
    $dd_blogengage->construstURL($link[0],$title,$dd_blogengage->get_button_design());
     
	$dd_left_float = '';
	$dd_right_float = '';
	$dd_before_content = '';
	$dd_after_content = '';
	
	$dd_sorting_data = array();
	$dd_sorting_data[$dd_digg->get_button_weight().'-'.$dd_digg->name] = $dd_digg;
	$dd_sorting_data[$dd_reddit->get_button_weight().'-'.$dd_reddit->name] = $dd_reddit;
	$dd_sorting_data[$dd_dzone->get_button_weight().'-'.$dd_dzone->name] = $dd_dzone;
	$dd_sorting_data[$dd_ybuzz->get_button_weight().'-'.$dd_ybuzz->name] = $dd_ybuzz;
	$dd_sorting_data[$dd_twitter->get_button_weight().'-'.$dd_twitter->name] = $dd_twitter;
	$dd_sorting_data[$dd_fbshare->get_button_weight().'-'.$dd_fbshare->name] = $dd_fbshare;
	$dd_sorting_data[$dd_fblike->get_button_weight().'-'.$dd_fblike->name] = $dd_fblike;
	$dd_sorting_data[$dd_polladium->get_button_weight().'-'.$dd_polladium->name] = $dd_polladium;
	$dd_sorting_data[$dd_stumbleupon->get_button_weight().'-'.$dd_stumbleupon->name] = $dd_stumbleupon;
	$dd_sorting_data[$dd_delicious->get_button_weight().'-'.$dd_delicious->name] = $dd_delicious;
	$dd_sorting_data[$dd_sphinn->get_button_weight().'-'.$dd_sphinn->name] = $dd_sphinn;
	$dd_sorting_data[$dd_comments->get_button_weight().'-'.$dd_comments->name] = $dd_comments;
	$dd_sorting_data[$dd_gbuzz->get_button_weight().'-'.$dd_gbuzz->name] = $dd_gbuzz;
	$dd_sorting_data[$dd_designbump->get_button_weight().'-'.$dd_designbump->name] = $dd_designbump;
	$dd_sorting_data[$dd_designfloat->get_button_weight().'-'.$dd_designfloat->name] = $dd_designfloat;
	$dd_sorting_data[$dd_webblend->get_button_weight().'-'.$dd_webblend->name] = $dd_webblend;
	$dd_sorting_data[$dd_blogengage->get_button_weight().'-'.$dd_blogengage->name] = $dd_blogengage;
	
	//sort i
	krsort($dd_sorting_data,SORT_NUMERIC);
	
	$content = generateDiggDiggDiv($content,$dd_sorting_data, $dd_line_up);
	
	//generate ajax floating on left, only display in post page
	if(is_single() && (get_option(DD_AJAX_LEFT_FLOAT_OPTION)==DD_DISPLAY_ON)){
		$content = generateAjaxFloatDiv($content,$dd_sorting_data);
	}

    return $content;
}

function generateAjaxFloatDiv($content,$dd_all_data){
	
	$result=DD_EMPTY_VALUE;
	
	foreach($dd_all_data as $obj){
		
		if($obj->get_ajax_left_float() == DD_DISPLAY_ON){
			$result .= "<div class='dd_button_v'>" .$obj->finalURL. "</div><div style='clear:left'></div>" ;	
		}
			
	}
	
	if($result != DD_EMPTY_VALUE){
		
		$result = "<div class='dd_ajax_float'>" . $result . "</div>";
		
		//when scrollbar beyond this y value, the ajax scroll effect started.
		$content = $result . "<div class='dd_content_wrap'>" . $content . "</div>";
		
	}
	
	return $content;
}

function generateDiggDiggDiv($content,$dd_all_data, $dd_line_up){
	
	$dd_before_content = '';
	$dd_after_content = ''; 
	$dd_left_float = ''; 
	$dd_right_float = '';
	
	foreach($dd_all_data as $obj){
		
		if($obj->get_append_type() == DD_SELECT_LEFT_FLOAT){
			$dd_left_float .= generateDiv($obj->finalURL,$dd_line_up,$obj->name);
		}else if($obj->get_append_type() == DD_SELECT_RIGHT_FLOAT){
			$dd_right_float .= generateDiv($obj->finalURL,$dd_line_up,$obj->name);
		}else if($obj->get_append_type() == DD_SELECT_BEFORE_CONTENT){
			$dd_before_content .= generateDiv($obj->finalURL,$dd_line_up,$obj->name);
		}else if($obj->get_append_type() == DD_SELECT_AFTER_CONTENT){
			$dd_after_content .= generateDiv($obj->finalURL,$dd_line_up,$obj->name);
		}
			
	}
	
	if($dd_before_content!=''){
		$dd_before_content = "<div class='dd_post_share'><div class='dd_buttons'>" . $dd_before_content. "</div></div><div style='clear:both'></div>";	
	}
		
	if($dd_after_content!=''){
		$dd_after_content = "<div class='dd_post_share'><div class='dd_buttons'>" . $dd_after_content. "</div></div><div style='clear:both'></div>";	
	}
	
	if($dd_left_float!=''){
		$dd_left_float = "<div class='dd_post_share dd_post_share_left'><div class='dd_buttons'>" . $dd_left_float. "</div></div>";	
	}
		
	if($dd_right_float!=''){
		$dd_right_float = "<div class='dd_post_share dd_post_share_right'><div class='dd_buttons'>" . $dd_right_float. "</div></div>";	
	}	
	
	$content = $dd_left_float . $dd_right_float . $dd_before_content . $content . $dd_after_content . DD_AUTHOR_SITE;
	
	return $content;
}

function generateDiv($link, $dd_line_up,$name){
	
	if($dd_line_up==DD_LINE_UP_HORIZONTAL){
		return "<div class='dd_button'>" .$link. "</div>" ;
	}else if($dd_line_up==DD_LINE_UP_VERTICAL){
		
		if ($name=="Facebook") {
			return "<div class='dd_button_v'>" .$link. "</div><div style='clear:left'></div>" ;		
		}
		else{
			return "<div class='dd_button_v'>" .$link. "</div>" ;
		}
		
	}else{
		return "<div class='dd_button'>" .$link. "</div>" ;
	}
	
}

/***********************************Advance Usage*********************************/

/**
 * Generate Digg button link
 * @param $buttonDesign Normal or Compact
 * @return Digg button link
 */
function digg_digg_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_digg = new DD_Digg();
    $dd_digg->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_digg->finalURL;
}	

/**
 * Generate Reddit button link
 * @param $buttonDesign Normal or Compact
 * @return Reddit button link
 */
function digg_digg_reddit_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_reddit = new DD_Reddit();
    $dd_reddit->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_reddit->finalURL;
}

/**
 * Generate Dzone button link
 * @param $buttonDesign Normal or Compact
 * @return Dzone button link
 */
function digg_digg_dzone_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_dzone = new DD_Dzone();
    $dd_dzone->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_dzone->finalURL;
}

/**
 * Generate YBuzz button link
 * @param $buttonDesign Normal or Compact
 * @return YBuzz button link
 */
function digg_digg_ybuzz_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_ybuzz = new DD_YBuzz();
    $dd_ybuzz->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_ybuzz->finalURL;
}

/**
 * Generate Twitter button link
 * @param $buttonDesign Normal or Compact
 * @return Twitter button link
 */
function digg_digg_twitter_generate($buttonDesign='Normal', $source=''){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_twitter = new DD_Twitter();
    $dd_twitter->construstURL($link[0],$source,$buttonDesign);
    
	echo $dd_twitter->finalURL;
}

/**
 * Generate Facebook button link
 * @param $buttonDesign Normal or Compact
 * @return Facebook button link
 */
function digg_digg_fbshare_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_fbshare = new DD_FbShare();
    $dd_fbshare->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_fbshare->finalURL;
}


/**
 * Generate Facebook like button link
 * @param $buttonDesign Like, Like + Text, Recommend, Recommend + Text
 * @return Facebook like button link
 */
function digg_digg_fblike_generate($buttonDesign='Like'){

	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_fblike = new DD_FbLike();
    $dd_fblike->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_fblike->finalURL;
}

/**
 * Generate Polladium button link
 * @param $buttonDesign Normal or Compact
 * @return Polladium button link
 */
function digg_digg_poll_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_polladium = new DD_Polladium();
    $dd_polladium->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_polladium->finalURL;
}
	

/**
 * Generate StumbleUpon button link
 * @param $buttonDesign Normal or Compact
 * @return StumbleUpon button link
 */
function digg_digg_stumbleupon_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_stumbleupon = new DD_StumbleUpon();
    $dd_stumbleupon->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_stumbleupon->finalURL;
}	

/**
 * Generate Delicious button link
 * @param $buttonDesign Normal or Compact
 * @return Delicious button link
 */
function digg_digg_delicious_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_delicious = new DD_Delicious();
    $dd_delicious->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_delicious->finalURL;
}	


/**
 * Generate Sphinn button link
 * @param $buttonDesign Normal or Compact
 * @return Sphinn button link
 */
function digg_digg_sphinn_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_sphinn = new DD_Sphinn();
    $dd_sphinn->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_sphinn->finalURL;
}	


/**
 * Generate post comments button link
 * @param $buttonDesign Normal or Compact
 * @return Post comments button link
 */
function digg_digg_post_comments_generate(){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $comments = $post->comment_count; //get post comments
    $postlink = get_permalink($id); //get post link
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_comments = new DD_Comments();
    $dd_comments->construstURL($link[0],$comments);
    
	echo $dd_comments->finalURL;
}	

/**
 * Generate Google Buzz button link
 * @param $buttonDesign Normal or Compact
 * @return GBuzz button link
 */
function digg_digg_gbuzz_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_gbuzz = new DD_GBuzz();
    $dd_gbuzz->construstURL($link[0],$title,get_bloginfo('url'),$buttonDesign);
    
	echo $dd_gbuzz->finalURL;
}

/**
 * Generate Designbump link
 * @param $buttonDesign Normal or Compact
 * @return DesignBump button link
 */
function digg_digg_designbump_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_designbump = new DD_DesignBump();
    $dd_designbump->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_designbump->finalURL;
}	

/**
 * Generate Designfloat link
 * @param $buttonDesign Normal or Compact
 * @return Designfloat button link
 */
function digg_digg_designfloat_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_designfloat = new DD_DesignFloat();
    $dd_designfloat->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_designfloat->finalURL;
}	

/**
 * Generate WebBlend link
 * @param $buttonDesign Normal or Compact
 * @return WebBlend button link
 */
function digg_digg_webblend_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_webblend = new DD_WebBlend();
    $dd_webblend->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_webblend->finalURL;
}	


/**
 * Generate BlogEngage link
 * @param $buttonDesign Normal or Compact
 * @return BlogEngagee button link
 */
function digg_digg_blogengage_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_blogengage = new DD_BlogEngage();
    $dd_blogengage->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_blogengage->finalURL;
}	

?>